      *   COPYRIGHT International Business Machines Corp. 1997    
      *   All Rights Reserved                                                
      *   Licensed Materials - Property of IBM                               
      *                                                                      
      *   US Government Users Restricted Rights - Use, duplication or        
      *   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  

      *****************************************************************
      * VERSION:     1.0                                              *
      * AUTHOR:      JIM MACNAIR                                      *
      *                                                               *
      *    SAMPLE TEMPLATE FOR NEW 3270 FRONT END                     *
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. EFHCBRW.
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       77  COMLEN       PIC S9(4) COMP.

      *****************************************************************
      *    NEW USER COMMAREA WITH ADDITIONAL FIELDS                   *
      *****************************************************************

       01  COMMAREA.
           COPY STDHEAD.
           02  USRCOMM.
      * INSERT BMS COPY COMMANDS HERE FOR ANY MAPS USED
      * IN THIS PROGRAM
           COPY USRBRWS.
           COPY EFHCGA.
           COPY EFHCGC.

       LINKAGE SECTION.
       01  DFHCOMMAREA.
           02  USRCOMM.
           COPY USRBRWS.

      *****************************************************************
      *    NEW PROGRAM TO REPLACE 3270 PROGRAM AND CALL THE NEW       *
      *    ECI CALLABLE VERSION OF THE BUSINESS LOGIC                 *
      *****************************************************************

       PROCEDURE DIVISION.
           EXEC CICS HANDLE CONDITION MAPFAIL(NODATA) END-EXEC.

      * CLEAR THE NEW COMMAREA
           MOVE LOW-VALUES TO COMMAREA

           IF EIBCALEN = 0 THEN
               MOVE 'MENU' TO USRMAPNAME
               MOVE 'DFHCGA' TO USRMAPSET
               EXEC CICS RECEIVE MAP('MENU') MAPSET('DFHCGA')
                   END-EXEC
           ELSE
               MOVE 'BROWSE' TO USRMAPNAME
               MOVE 'DFHCGC' TO USRMAPSET
               EXEC CICS RECEIVE MAP('BROWSE') MAPSET('DFHCGC')
                   END-EXEC
           END-IF

      * INSURE THAT WE DON'T HIT MAPFAIL CONDITIONS
           MOVE 1 TO USRMAPLN.
           GO TO MAPOK.

      * SIMULATE A MAPFAIL CONDITION IN THE CALLED PROGRAM
       NODATA.
           MOVE ZERO TO USRMAPLN.

       MAPOK.
      *****************************************************************
      * SET THE USER EIB FIELDS FROM THE REAL EIB
      *****************************************************************

           MOVE EIBTRNID TO USRTRNID.
           MOVE EIBTRMID TO USRTRMID.
           MOVE EIBCALEN TO USRCALEN.
           MOVE EIBCPOSN TO USRCPOSN.
           MOVE EIBAID   TO USRAID.
           MOVE ZEROS    TO USRVERSION.
           MOVE SPACE    TO ERASESW.
           MOVE ZEROS    TO RETCODE.
           MOVE LOW-VALUES TO NXTRNID.

      *****************************************************************
      * MOVE IN THE USER COMMAREA INTO THE PASSED COMMAREA
      *****************************************************************

           IF EIBCALEN NOT = 0 THEN
               MOVE USRCOMM OF DFHCOMMAREA TO USRCOMM OF COMMAREA
           END-IF

      *****************************************************************
      * LINK TO THE CONVERTED PROGRAM
      *****************************************************************
           EXEC CICS LINK PROGRAM('NEWCBRW')
               COMMAREA(COMMAREA) LENGTH(LENGTH OF COMMAREA)
           END-EXEC.

      *****************************************************************
      *    ROUTINE TO SEND THE TERMINAL DATA BACK TO THE TERMINAL     *
      *****************************************************************
       MAP-SEND.

           IF USRMAPNAME = 'BROWSE' AND
               ERASESW IS EQUAL TO 'E' THEN
               EXEC CICS SEND MAP('BROWSE') MAPSET('DFHCGC')
                   ERASE    END-EXEC
           END-IF
           IF USRMAPNAME = 'MENU' AND
               ERASESW IS EQUAL TO 'E' THEN
               EXEC CICS SEND MAP('MENU') MAPSET('DFHCGA')
                   ERASE    END-EXEC
           END-IF

           IF USRMAPNAME = 'SENDTEXT' THEN
               IF ERASESW IS EQUAL TO 'E' THEN
               EXEC CICS SEND TEXT FROM(TEXTAREA) ERASE
               LENGTH(LENGTH OF TEXTAREA) END-EXEC
           ELSE
               EXEC CICS SEND TEXT FROM(TEXTAREA)
               LENGTH(LENGTH OF TEXTAREA) END-EXEC
           END-IF.

      *****************************************************************
      *    ROUTINE TO RETURN, WITH OPTIONAL TRANSID AND COMMAREA      *
      *****************************************************************

       RETURN-TO-CICS.
      *****************************************************************
      * CHECK FOR A RETURN WITH TRANSID.  IF FOUND, THEN
      * GET THE USER COMMAREA LENGTH TO DETERMINE IF THERE IS
      * A USER COMMAREA ON THE RETURN.
      *****************************************************************

           IF NXTRNID IS NOT EQUAL TO LOW-VALUES
               MOVE USRCALEN OF COMMAREA TO COMLEN

               IF COMLEN IS GREATER THAN 0
                   EXEC CICS RETURN TRANSID(NXTRNID)
                        COMMAREA(USRCOMM OF COMMAREA) LENGTH(COMLEN)
                   END-EXEC
               ELSE
                   EXEC CICS RETURN TRANSID(NXTRNID)
                   END-EXEC
               END-IF
           END-IF

           EXEC CICS RETURN END-EXEC.
           GOBACK.
