      *   COPYRIGHT International Business Machines Corp. 1997    
      *   All Rights Reserved                                                
      *   Licensed Materials - Property of IBM                               
      *                                                                      
      *   US Government Users Restricted Rights - Use, duplication or        
      *   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.  

      ***************************************************************
      * VERSION:     1.1
      * COPYRIGHT:
      *
      *   (C) COPYRIGHT International Business Machines Corp. 1993, 1997
      *   All Rights Reserved
      *   Licensed Materials - Property of IBM
      *
      *   US Government Users Restricted Rights - Use, duplication or
      *   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
      *
      *
      ***************************************************************
      *****************************************************************
      *    EFHCALL - CICS SAMPLE FILEA INQUIRY/UPDATE - COBOL         *
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. EFHCALL.
       ENVIRONMENT DIVISION.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
       77  COMLEN       PIC S9(4) COMP.

       01  COMMAREA.
           COPY STDHEAD.
           COPY USRCOMM.
           COPY EFHCGA.
           COPY EFHCGB.

      *****************************************************************
      *    NEW USER COMMAREA WITH ADDITIONAL FIELDS                   *
      *****************************************************************
       LINKAGE SECTION.
       01  DFHCOMMAREA.
           COPY USRCOMM.

      *****************************************************************
      *    NEW PROGRAM TO REPLACE 3270 PROGRAM AND CALL THE NEW       *
      *    ECI CALLABLE VERSION OF DFHCALL BUSINESS LOGIC             *
      *****************************************************************
       PROCEDURE DIVISION.
           EXEC CICS HANDLE CONDITION MAPFAIL(NODATA) END-EXEC.

           IF EIBCALEN NOT = 0 THEN
              MOVE DFHCOMMAREA TO USRCOMMAREA OF COMMAREA
              MOVE 'DETAIL' TO USRMAPNAME
              EXEC CICS RECEIVE MAP('DETAIL') MAPSET('DFHCGB')
              INTO(DETAILI)
              END-EXEC
           ELSE
              MOVE LOW-VALUES TO COMMAREA
              MOVE 'MENU' TO USRMAPNAME
              EXEC CICS RECEIVE MAP('MENU') MAPSET('DFHCGA')
              INTO(MENUI)
              END-EXEC.

      * INSURE THAT WE DON'T HIT MAPFAIL CONDITIONS
           MOVE 1 TO USRMAPLN.
           GO TO MAPOK.

      * SIMULATE A MAPFAIL CONDITION IN THE CALLED PROGRAM
       NODATA.
           MOVE ZERO TO USRMAPLN.

       MAPOK.
           MOVE EIBTRNID TO USRTRNID.
           MOVE EIBTRMID TO USRTRMID.
           MOVE EIBCALEN TO USRCALEN.
           MOVE EIBCPOSN TO USRCPOSN.
           MOVE SPACE TO ERASESW.
           MOVE LOW-VALUES TO NXTRNID.
           MOVE ZEROS TO RETCODE.
           EXEC CICS LINK PROGRAM('NEWCALL') COMMAREA(COMMAREA)
           LENGTH(LENGTH OF COMMAREA) END-EXEC.

      *****************************************************************
      *    ROUTINE TO SEND THE TERMINAL DATA BACK TO THE TERMINAL     *
      *****************************************************************
       MAP-SEND.
           IF USRMAPNAME = 'SENDTEXT' THEN
               EXEC CICS SEND TEXT FROM(TEXTAREA) LENGTH(100)
               END-EXEC
           END-IF

           IF USRMAPNAME = 'DETAIL' THEN
               IF ERASESW IS EQUAL TO 'E' THEN
                   EXEC CICS SEND MAP(USRMAPNAME) MAPSET('DFHCGB')
                   FROM(DETAILO)
                   ERASE END-EXEC
               ELSE
                   EXEC CICS SEND MAP(USRMAPNAME) MAPSET('DFHCGB')
                   FROM(DETAILO)
                   END-EXEC
               END-IF
           END-IF

           IF USRMAPNAME = 'MENU' THEN
               IF ERASESW IS EQUAL TO 'E' THEN
                   EXEC CICS SEND MAP('MENU') MAPSET('DFHCGA')
                   FROM(MENUO)
                   ERASE END-EXEC
               ELSE
                   EXEC CICS SEND MAP('MENU') MAPSET('DFHCGA')
                   FROM(MENUO)
                   ERASE END-EXEC
               END-IF
           END-IF.

      *****************************************************************
      *    ROUTINE TO RETURN, WITH OPTIONAL TRANSID AND COMMAREA      *
      *****************************************************************
       MENU.
           IF NXTRNID IS NOT EQUAL TO LOW-VALUES
               MOVE USRCALEN TO COMLEN
               IF COMLEN IS GREATER THAN 0
                   EXEC CICS RETURN TRANSID(NXTRNID)
                        COMMAREA(USRCOMMAREA OF COMMAREA) LENGTH(COMLEN)
                   END-EXEC
               ELSE
                   EXEC CICS RETURN TRANSID(NXTRNID)
                   END-EXEC
               END-IF
           END-IF

           EXEC CICS RETURN END-EXEC.
           GOBACK.
